import xml.dom.minidom

import ode

import geometry

class Environment:
	def __init__(self, environment_data):
		self.ode_space = ode.Space(type=1) # Create a HashSpace
		self.geoms = []
		
		xmldoc = xml.dom.minidom.parseString(environment_data)
		environment_xml = xmldoc.getElementsByTagName("Environment")[0]
		for geom_xml in environment_xml.getElementsByTagName("Geometry"):
			self.geoms.append(geometry.Geometry.get_geometry(self.ode_space, geom_xml))
	
	def restart(self):
		pass
	
	def draw(self):
		for geom in self.geoms:
			geom.draw()