from OpenGL import GL
import Image
import pygame

import texture
import data

g_font = None

class Font(texture.Texture):
	def __init__(self):
		image = Image.open(data.get_filename("font.png"))
		image.load()
		super(Font,self).__init__(image)
	
	@staticmethod
	def get_font():
		global g_font
		if None == g_font:
			g_font = Font()
		return g_font
	
	def draw(self, text):
		GL.glBindTexture(GL.GL_TEXTURE_2D, self.texture)
		
		count = 0
		for char in text:
			position = (12*(ord(char)%32), 32*(ord(char)/32))
			
			GL.glMatrixMode(GL.GL_TEXTURE)
			GL.glPushMatrix()
			GL.glTranslatef(position[0]/float(self.size[0]),position[1]/float(self.size[1]),0)
			GL.glScalef(12/float(self.size[0]),32/float(self.size[1]),1)
			
			GL.glMatrixMode(GL.GL_MODELVIEW)
			GL.glPushMatrix()
			GL.glTranslatef(12*count,0,0)
			GL.glScalef(12,32,1)
			
			GL.glBegin(GL.GL_QUADS)
			for pair in [(0,0),(0,1),(1,1),(1,0)]:
				GL.glTexCoord2f(*pair)
				GL.glVertex2f(*pair)
			GL.glEnd()
			
			GL.glMatrixMode(GL.GL_TEXTURE)
			GL.glPopMatrix()
			GL.glMatrixMode(GL.GL_MODELVIEW)
			GL.glPopMatrix()
			
			count += 1
		
		GL.glBindTexture(GL.GL_TEXTURE_2D, 0)
