from OpenGL import GL, GLUT
import ode

class Geometry(object):
	def __init__(self, ode_space, geometry_xml):
		self.ode_space = ode_space
		self.ode_geom = None
		self.position = eval("[%s]" % geometry_xml.getAttribute("Position"))
		self.size = eval("[%s]" % geometry_xml.getAttribute("Size"))
		self.color = eval("[%s]" % geometry_xml.getAttribute("Color"))
	
	def draw(self):
		GL.glColor4f(*self.color)
		GL.glPushMatrix()
		GL.glTranslatef(*self.position)
		GL.glScalef(*self.size)
		self.class_specific_draw()
		GL.glPopMatrix()
	
	def class_specific_draw(self):
		pass
	
	@staticmethod
	def get_geometry(ode_space, geometry_xml):
		type = geometry_xml.getAttribute("Type")
		if "Box" == type:
			return BoxGeometry(ode_space, geometry_xml)
		raise Exception("Unrecognized geometry type %s" % type)

class BoxGeometry(Geometry):
	def __init__(self, ode_space, box_xml):
		super(BoxGeometry, self).__init__(ode_space, box_xml)
		self.ode_geom = ode.GeomBox(self.ode_space, self.size)
		self.ode_geom.setPosition(self.position)
	def class_specific_draw(self):
		GLUT.glutSolidCube(1)
