import time

import pygame
import ode

import manager
import texture

g_manager_object = None
g_last_time = None
g_end_game = None

def handle_event(event):
	global g_end_game
	global g_manager_object
	
	if True == g_manager_object.handle_event(event):
		g_end_game = True
	
	if event.type == pygame.QUIT:
		g_end_game = True
	
def idle():
	global g_last_time, g_end_game
	
	cur_time = time.time()
	time_delta = cur_time - g_last_time
	g_last_time = cur_time
	
	g_manager_object.do_frame(time_delta)
	if g_manager_object.ended:
		g_end_game = True
	
	pygame.display.flip()

def main():
	global g_last_time
	global g_end_game
	global g_manager_object
	
	pygame.init()
	flags = pygame.HWSURFACE | pygame.DOUBLEBUF | pygame.OPENGL # | pygame.FULLSCREEN
	window = pygame.display.set_mode((800,600),flags)
	
	g_manager_object = manager.Manager()
	
	g_last_time = time.time()
	
	g_end_game = False
	while not g_end_game:
		events = pygame.event.get()
		for event in events:
			handle_event(event)
		if events == []:
			idle()
	
	texture.clear_cache()
	ode.CloseODE()
	pygame.quit()
	print "Thanks for playing!"
	print "Go grab a cake."
