import screen
import level_screen
import data

class Manager:
	def __init__(self):
		self.current_screen = None
		self.all_levels = eval(data.load("levels","levels_list.txt"))
		self.ended = False
		
		self.load_level()
	
	def load_level(self):
		if None != self.current_screen:
			self.current_screen.close()
		self.current_screen = level_screen.LevelScreen(self.all_levels[0])
	
	def pop_level(self):
		if self.current_screen.game_status == level_screen.STATUS_HAS_WON:
			self.all_levels = self.all_levels[1:]
		if len(self.all_levels) > 0:
			self.load_level()
		else:
			self.ended = True
	
	def handle_event(self, event):
		self.current_screen.handle_event(event)
	
	def do_frame(self, time_delta):
		if True == self.current_screen.do_frame(time_delta):
			self.pop_level()
			return
		
		self.current_screen.draw()
	