from OpenGL import GL
import Image

import data

g_stored_textures = {}
def get(name):
	global g_stored_textures
	if not g_stored_textures.has_key(name):
		image = Image.open(data.get_filename("textures", name + ".png"))
		image.load()
		g_stored_textures[name] = Texture(image)
	return g_stored_textures[name]
def clear_cache():
	global g_stored_textures
	g_stored_textures = {}

class Texture(object):
	def __init__(self, image):
		self.size = image.size
		
		self.texture = GL.glGenTextures(1)
		GL.glBindTexture(GL.GL_TEXTURE_2D, self.texture)
		GL.glTexImage2D(
			GL.GL_TEXTURE_2D, #target
			0, #level
			4, #internal format
			image.size[0], image.size[1], #size
			0, #border
			GL.GL_RGBA, #format
			GL.GL_UNSIGNED_BYTE,
			image.tostring())
		GL.glTexParameteri(GL.GL_TEXTURE_2D, GL.GL_TEXTURE_MAG_FILTER, GL.GL_NEAREST)
		GL.glTexParameteri(GL.GL_TEXTURE_2D, GL.GL_TEXTURE_MIN_FILTER, GL.GL_NEAREST)
		GL.glBindTexture(GL.GL_TEXTURE_2D, 0)
	
	def draw(self):
		GL.glBindTexture(GL.GL_TEXTURE_2D, self.texture)
		GL.glPushMatrix()
		GL.glScalef(self.size[0],self.size[1],1)
		GL.glBegin(GL.GL_QUADS)
		for pair in [(0,0),(0,1),(1,1),(1,0)]:
			GL.glTexCoord2f(*pair)
			GL.glVertex2f(*pair)
		GL.glEnd()
		GL.glPopMatrix()
		
		GL.glBindTexture(GL.GL_TEXTURE_2D, 0)
	
	def __del__(self):
		GL.glDeleteTextures([self.texture])
